"use strict";

exports.__esModule = true;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PubSub = function () {
  function PubSub() {
    (0, _classCallCheck3.default)(this, PubSub);
    this.subscribers = [];
    this.lastSubscriberId = 0;
  }

  PubSub.prototype.subscribe = function subscribe(fn) {
    this.lastSubscriberId = this.lastSubscriberId + 1;
    this.subscribers.push({
      callback: fn,
      id: this.lastSubscriberId
    });
    return this.lastSubscriberId;
  };

  PubSub.prototype.unsubscribe = function unsubscribe(id) {
    if (id) {
      for (var i = this.subscribers.length - 1; i >= 0; i -= 1) {
        if (this.subscribers[i].id === id) {
          this.subscribers.splice(i, 1);
          return true;
        }
      }
    }
    return false;
  };

  PubSub.prototype.unsubscribeAll = function unsubscribeAll() {
    this.subscribers = [];
    this.lastSubscriberId = 0;
  };

  PubSub.prototype.publish = function publish() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    this.subscribers.forEach(function (subscriber) {
      subscriber.callback.apply(null, args);
    });
  };

  return PubSub;
}();

var _default = PubSub;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(PubSub, "PubSub", "/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/PubSub.js");

  __REACT_HOT_LOADER__.register(_default, "default", "/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/PubSub.js");
}();

;